;;; Mode: Lisp; Package: http

;;; Author: John Domingue

;;; The Open University

(in-package "HTTP")

;;some useful additions
(defun get-decoded-form-value (form name)
  (let* ((string-name (string-downcase (format nil "~a" name)))
         (position (search string-name form)) start)
    (when position
      (setf start (+ 1 position (length string-name)))
      (if (find #\? form :start start)
          (read-from-string (subseq form start (position #\? form :start start)))            
          (read-from-string (subseq form start))))))

(defun get-decoded-form-string-value (form name)
  (let* ((string-name (string-downcase (format nil "~a" name)))
         (position (search string-name form)) start)
    (when position
      (setf start (+ 1 position (length string-name)))
      (if (find #\? form :start start)
          (subseq form start (position #\? form :start start))           
          (subseq form start)))))

(defun cl-user::get-decoded-form-value (form name)
  (get-decoded-form-value form name))

(defun empty-string-p (string)
  (zerop (length string)))