;;; Mode: Lisp; Package: ocml

;;; Author: John Domingue

;;; The Open University

(in-package "OCML")

(in-ontology base-ontology)


(def-relation quiver-range (?root-class ?item ?range)
  :argument-types (class instance string)
  :prove-by
  (= ?range (quiver-range ?root-class ?item)))

(def-function quiver-range (?root-class-name ?item)
  :lisp-fun #'(lambda (root-class-name item) 
                (let ((root-class (get-domain-class root-class-name))
                      (class (class-of (find-instance item))))
                  (format nil "[~d,~d]" (slider-start class)
                          (slider-end class)))))