;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology wsmo-test)

(def-class exchange-rate-goal (goal)
  (;;(used-mediator :type mediator)
   ;;(has-post-condition :type post-condition)
   ;;(has-effect :type effect)
   ;;;;;extra to wsmo 
   (has-input-soap-binding :value (has_source_currency "sexpr")
                   :value (has_target_currency "sexpr"))
   (has-output-soap-binding :value (has_exchange_rate "float"))
   (has-input-role :value has_source_currency 
                   :value has_target_currency)
   (has-output-role :value has_exchange_rate)
   (has_source_currency :type currency)
   (has_target_currency :type currency)
   (has_exchange_rate :type positive-number)))

(def-class exchange-rate-mediator (wg-mediator)
  ((has-source-component :value exchange-goal)
   (has-target-component :value exchange-web-service-goal)
   (has-mediation-service :value exchange-rate-mediation-service)))

(def-class exchange-rate-web-service (web-service)
  ((used-mediator :value exchange-rate-oo-mediator)))

(def-class european-exchange-rate-web-service (exchange-rate-web-service)
  ((has-capability :value european-exchange-rate-capability)
   (has-interface :value european-exchange-rate-interface)))

(def-class non-european-exchange-rate-web-service (exchange-rate-web-service)
  ((has-capability :value non-european-exchange-rate-capability)))

(def-class european-bank-exchange-rate-web-service (exchange-rate-web-service)
  ((has-capability :value european-bank-exchange-rate-capability)
   (has-interface :value european-bank-exchange-rate-interface)))


(def-class european-exchange-rate-capability (capability)
  (;;(used-mediator :type oo-mediator)
   ;;(has-pre-condition :type pre-condition)
   ;;(has-post-condition :type post-condition)
   ;;(has-assumption :type assumption)
   ;;(has-effect :type effect)
   ;;extra to wsmo - directly links a capability to a goal
   (solves-goal :value exchange-rate-goal)
   (has-applicability-condition 
    :value
    (kappa (?goal)
           (or (= (role-value ?goal 
                              'has_source_currency)
                  pound)
               (= (role-value ?goal 
                              'has_source_currency)
                  euro))))))

(def-class european-bank-exchange-rate-capability (capability)
  (;;(used-mediator :type oo-mediator)
   ;;(has-pre-condition :type pre-condition)
   ;;(has-post-condition :type post-condition)
   ;;(has-assumption :type assumption)
   ;;(has-effect :type effect)
   ;;extra to wsmo - directly links a capability to a goal
   (solves-goal :value exchange-rate-goal)
   (has-applicability-condition 
    :value
    (kappa (?goal)
           (or (= (role-value ?goal 
                              'has_source_currency)
                  rupee))))))

(def-class non-european-exchange-rate-capability (capability)
  (;;(used-mediator :type oo-mediator)
   ;;(has-pre-condition :type pre-condition)
   ;;(has-post-condition :type post-condition)
   ;;(has-assumption :type assumption)
   ;;(has-effect :type effect)
   ;;extra to wsmo - directly links a capability to a goal
   (solves-goal :value exchange-rate-goal)
   (has-applicability-condition 
    :value
    (kappa (?goal)
           (or (= (role-value ?goal 
                              'has_source_currency)
                  us-dollar)
               (= (role-value ?goal 
                              'has_source_currency)
                  yen))))))

(def-class exchange-rate-interface (interface) 
  ((has-choreography :value exchange-rate-choreography)
   ;;(has-orchestration :type orchestration)
   ;;(used-mediator :type oo-mediator)
   ))

(def-class exchange-rate-choreography (choreography)
  ((has-web-service-host :value "137.108.24.211")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))

#|
(def-class exchange-rate-choreography (choreography)
  ((has-web-service-host :value "localhost")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))
|#

(def-class european-exchange-rate-interface (exchange-rate-interface))

(def-class european-bank-exchange-rate-interface (interface)
  ((has-address :value "666 555")
   (has-url :value "7788" :value "http://foo.open.ac.uk" :value "john")
   (has-value :value 333)))
