;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology wsmo-test)

(def-class exchange-rate-goal (goal)
  (;;(used-mediator :type mediator)
   ;;(has-post-condition :type post-condition)
   ;;(has-effect :type effect)
   ;;;;;extra to wsmo 
   (has-input-soap-binding :value (has_source_currency "sexpr")
                   :value (has_target_currency "sexpr"))
   (has-output-soap-binding :value (has_exchange_rate "float"))
   (has-input-role :value has_source_currency 
                   :value has_target_currency)
   (has-output-role :value has_exchange_rate)
   (has_source_currency :type currency)
   (has_target_currency :type currency)
   (has_exchange_rate :type positive-number)))

(def-class exchange-rate-goal-child (exchange-rate-goal))

(def-class exchange-rate-mediator (wg-mediator)
  ((has-source-component :value exchange-goal)
   (has-target-component :value exchange-web-service-goal)
   (has-mediation-service :value exchange-rate-mediation-service)))

(def-class exchange-rate-web-service (web-service)
  ((used-mediator :value exchange-rate-oo-mediator)))

(def-class european-exchange-rate-web-service (exchange-rate-web-service)
  ((has-capability :value european-exchange-rate-capability)
   (has-interface :value european-exchange-rate-interface)))

(def-class non-european-exchange-rate-web-service (exchange-rate-web-service)
  ((has-capability :value non-european-exchange-rate-capability)
   (has-interface :value non-european-exchange-rate-web-service-interface40662)))

(def-class european-bank-exchange-rate-web-service (exchange-rate-web-service)
  ((has-capability :value european-bank-exchange-rate-capability)
   (has-interface :value european-bank-exchange-rate-interface)))


(def-class european-exchange-rate-capability (capability)
  (;;(used-mediator :type oo-mediator)
   ;;(has-pre-condition :type pre-condition)
   ;;(has-post-condition :type post-condition)
   ;;(has-assumption :type assumption)
   ;;(has-effect :type effect)
   ;;extra to wsmo - directly links a capability to a goal
   (solves-goal :value exchange-rate-goal)
   (has-applicability-condition 
    :value
    (kappa (?goal)
           (or (= (role-value ?goal 
                              'has_source_currency)
                  pound)
               (= (role-value ?goal 
                              'has_source_currency)
                  euro))))))

(def-class european-bank-exchange-rate-capability (capability)
  (;;(used-mediator :type oo-mediator)
   ;;(has-pre-condition :type pre-condition)
   ;;(has-post-condition :type post-condition)
   ;;(has-assumption :type assumption)
   ;;(has-effect :type effect)
   ;;extra to wsmo - directly links a capability to a goal
   (solves-goal :value exchange-rate-goal)
   (has-applicability-condition 
    :value
    (kappa (?goal)
           (or (= (role-value ?goal 
                              'has_source_currency)
                  rupee))))))

(def-class non-european-exchange-rate-capability (capability)
  (;;(used-mediator :type oo-mediator)
   ;;(has-pre-condition :type pre-condition)
   ;;(has-post-condition :type post-condition)
   ;;(has-assumption :type assumption)
   ;;(has-effect :type effect)
   ;;extra to wsmo - directly links a capability to a goal
   (solves-goal :value exchange-rate-goal)
   (has-applicability-condition 
    :value
    (kappa (?goal)
           (or (= (role-value ?goal 
                              'has_source_currency)
                  us-dollar)
               (= (role-value ?goal 
                              'has_source_currency)
                  yen))))))

(def-class exchange-rate-interface (interface) 
  ((has-choreography :value exchange-rate-choreography)
   ;;(has-orchestration :type orchestration)
   ;;(used-mediator :type oo-mediator)
   ))

(def-class exchange-rate-choreography (choreography)
  ((has-web-service-host :value "localhost")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))

#|
(def-class exchange-rate-choreography (choreography)
  ((has-web-service-host :value "localhost")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))
|#

(def-class european-exchange-rate-interface (exchange-rate-interface))

(def-class european-bank-exchange-rate-interface (interface)
  ((has-value :value 333)
   (has-url :value "7788" :value "http://foo.open.ac.uk" :value "john")
   (has-address :value "666 555")
   (has-choreography :value european-bank-exchange-rate-web-service-choreography40499)))


(def-class european-bank-exchange-rate-web-service-choreography40499 (choreography)
  ((has-web-service-host :value "192.168.0.2")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))

(def-class non-european-exchange-rate-web-service-interface40662 (interface)
  ((has-choreography :value non-european-exchange-rate-web-service-choreography40663)))

(def-class non-european-exchange-rate-web-service-choreography40663 (choreography)
  ((has-web-service-host :value "192.168.0.2")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))

(def-class exchange-rate-european-web-service-interface20607 (interface)
  ((has-choreography :value exchange-rate-european-web-service-choreography20608)))

(def-class exchange-rate-european-web-service-choreography20608 (choreography)
  ((has-web-service-host :value "localhost")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))

(def-class wsmo-test_non-european-exchange-rate-web-service-interface27491 (interface)
  ((has-choreography :value wsmo-test_non-european-exchange-rate-web-service-choreography27492)))

(def-class wsmo-test_non-european-exchange-rate-web-service-choreography27492 (choreography)
  ((has-web-service-host :value "192.168.0.2")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))

(def-class wsmo-test_european-bank-exchange-rate-web-service-interface27529 (interface)
  ((has-choreography :value wsmo-test_european-bank-exchange-rate-web-service-choreography27530)))

(def-class wsmo-test_european-bank-exchange-rate-web-service-choreography27530 (choreography)
  ((has-web-service-host :value "192.168.0.2")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))

(def-class wsmo-test_european-exchange-rate-web-service-interface27567 (interface)
  ((has-choreography :value wsmo-test_european-exchange-rate-web-service-choreography27568)))

(def-class wsmo-test_european-exchange-rate-web-service-choreography27568 (choreography)
  ((has-web-service-host :value "192.168.0.2")
   (has-web-service-port :value 3001)
   (has-web-service-location :value "/soap")))

(def-class exchange-rate-goal2
           (goal)
           ?goal
           ((has-input-role
             :value
             has_source_currency
             :value
             has_target_currency)
            (has-input-soap-binding
             :value
             (has_source_currency "sexpr")
             :value
             (has_target_currency "sexpr"))
            (has-output-role :value exchange-rate)
            (has-ouput-soap-binding :value (exchange-rate "float"))
            (has_source_currency :type currency)
            (has_target_currency :type currency)
            (exchange-rate :type integer)
            (has-effect
             :value
             (invoice-sent has_source_currency has_target_currency))
            (used-mediator :value mediator99)
            (has-post-condition
             :value
             (the-exchange-rate
              has_source_currency
              has_target_currency))))

(def-class exchange-rate-web-service2
           (web-service)
           ?web-service
           ((has-input-role
             :value
             has_source_currency
             :value
             has_target_currency)
            (has-output-role :value exchange-rate)
            (has_source_currency :type currency)
            (has_target_currency :type currency)
            (exchange-rate :type integer)
            (has-capability :value exchange-rate-capability2)
            (has-interface :value exchange-rate-interface2)
            (used-mediator :value exchange-rate-oo-mediator2)
            (has-internal-method :value exchange-rate-fun)))

(def-class exchange-rate-interface2
           (interface)
           ?interface
           ((used-mediator :value exchange-rate-mediator2)
            (has-choreography :value exchange-rate-choreography2)
            (has-orchestration :value exchange-rate-orchestration2)))

(def-class exchange-rate-mediator2
           (wg-mediator)
           ?mediator
           ((used-mediator :value mediator44)
            (has-source-component :value exchange-rate-goal2)
            (has-target-component :value exchange-rate-web-service2)
            (has-mediation-service :value mediation-service-fun)
            (has-reduction
             :value
             (kappa (x) (european_exchange-rate x)))))