;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology wsmo-use-case)



(def-class buy-train-ticket-service-interface (interface)
  ((has-choreography :value buy-train-ticket-service-choreography)))

(def-class buy-train-ticket-service-choreography (choreography)
  ((has-grounding :value
                  ((grounded-to-lisp (normal book-english-train-journey))))))

(def-class french-buy-train-ticket-service-interface (interface)
  ((has-choreography :value french-buy-train-ticket-service-choreography)
   (has-publisher-information :value french-buy-train-ticket-service-publisher-information)))


(DEF-CLASS FRENCH-BUY-TRAIN-TICKET-SERVICE-CHOREOGRAPHY
  (CHOREOGRAPHY)
  ((has-grounding 
    :value 
    ((grounded-to-lisp (normal
      book-french-train-journey))))))

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY
             :VALUE
             EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE-CHOREOGRAPHY)
            (HAS-ORCHESTRATION
             :VALUE
             EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-CHOREOGRAPHY
           (CHOREOGRAPHY)
           ((has-grounding :value ((normal
                                    book-student-european-train-journey)))))

(def-class europe-business-buy-train-ticket-service-interface (interface)
  ((has-choreography :value europe-business-buy-train-ticket-service-choreography)
   (has-publisher-information :value europe-business-buy-train-ticket-service-publisher-information)))


(DEF-CLASS EUROPE-BUSINESS-BUY-TRAIN-TICKET-SERVICE-CHOREOGRAPHY
  (CHOREOGRAPHY)
  ((has-grounding 
    :value ((grounded-to-lisp 
             (normal
             book-business-european-train-journey))))))

(def-class german-buy-train-ticket-service-interface (interface)
  ((has-choreography :value german-buy-train-ticket-service-choreography)
   (has-publisher-information :value german-buy-train-ticket-service-publisher-information)))

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE-CHOREOGRAPHY)
            (HAS-ORCHESTRATION
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-CHOREOGRAPHY
  (CHOREOGRAPHY)
  ((has-grounding
    :value
    ((grounded-to-lisp
      (normal
       book-austrian-train-journey))))))

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY
             :VALUE
             ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE-CHOREOGRAPHY)
            (HAS-ORCHESTRATION
             :VALUE
             ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-SERVICE-CHOREOGRAPHY
  (CHOREOGRAPHY)
  ((has-grounding 
    :value
    ((grounded-to-lisp
      (normal
       book-english-train-journey))))))

(def-class get-train-timetable-service-interface (interface)
  ((has-choreography :value get-train-timetable-service-choreography)
   (has-publisher-information :value get-train-timetable-service-publisher-information)))

(DEF-CLASS GET-TRAIN-TIMETABLE-SERVICE-CHOREOGRAPHY
           (CHOREOGRAPHY)
           ((has-grounding
             :value
             ((grounded-to-lisp
               (normal
                get-train-times))))))

(def-class universal-time-buy-train-ticket-mediation-service-interface (interface)
  ((has-choreography :value universal-time-buy-train-ticket-mediation-service-choreography)
   (has-publisher-information :value universal-time-buy-train-ticket-mediation-service-publisher-information)))

(DEF-CLASS UNIVERSAL-TIME-BUY-TRAIN-TICKET-MEDIATION-SERVICE-CHOREOGRAPHY
           (CHOREOGRAPHY)
           ((has-grounding 
            :value
            ((grounded-to-lisp (normal
                                mediate-time))))))


(DEF-CLASS german-buy-train-ticket-service-choreography
  (choreography)
  ((has-grounding :value 
                  (
#|                   (normal
                    book-german-train-journey
                    ((has-person "sexpr")
                     (has-departure-station "sexpr")
                     (has-destination-station "sexpr")
                     (has-date-and-time "sexpr"))
                    "string")
                                      (first-class-upgrade
                    book-first-class-upgrade-german-train-journey
                    ((has-person "sexpr")
                     (has-departure-station "sexpr")
                     (has-destination-station "sexpr")
                     (has-date-and-time "sexpr"))
                    "string")
                   (standard-class
                    book-standard-class-german-train-journey
                    ((has-person "sexpr")
                     (has-departure-station "sexpr")
                     (has-destination-station "sexpr")
                     (has-date-and-time "sexpr"))
                    "string")
                   (acknowledge-error
                    acknowledge-error-message
                    ((has-acknowledgement "int"))
                    "string")
|#
                   (grounded-to-lisp 
                    (normal
                     book-german-train-journey
                     ((has-person "sexpr")
                      (has-departure-station "sexpr")
                      (has-destination-station "sexpr")
                      (has-date-and-time "sexpr"))
                     "string"))
                   (grounded-to-lisp
                    (first-class-upgrade
                     book-first-class-upgrade-german-train-journey
                     ((has-person "sexpr")
                      (has-departure-station "sexpr")
                      (has-destination-station "sexpr")
                      (has-date-and-time "sexpr"))
                     "string"))
                   (grounded-to-lisp
                    (standard-class
                     book-standard-class-german-train-journey
                     ((has-person "sexpr")
                      (has-departure-station "sexpr")
                      (has-destination-station "sexpr")
                      (has-date-and-time "sexpr"))
                     "string"))
                   (grounded-to-lisp
                    (acknowledge-error
                     acknowledge-error-message
                     ((has-acknowledgement "int"))
                     "string"))))
   (has-guarded-transitions
    :value
    ((start 
      (init-choreography)
      then
      (send-message 'normal))

     (accept-first-class-upgrade
      (received-message normal ?result)
      (upgrade-class ?result)
      (operation-input normal has-person ?person)
      (accept-upgrade ?person ?accept-upgrade)
      then
      (send-message 'first-class-upgrade)
      (end-choreography))

     (do-not-accept-first-class-upgrade
      (received-message normal ?result)
      (upgrade-class ?result)
      (operation-input normal has-person ?person)
      (not (accept-upgrade ?person ?accept-upgrade))
      then
      (send-message 'standard-class)
      (end-choreography))
     (date-error-transition
      (received-error normal ?error-message ?error-type)
      (date-format-error ?error-type)
      then
      (send-message-with-new-input-role-pairs
       'acknowledge-error ((has-acknowledgement 0)))
      (end-choreography))
     (passenger-error-transition
      (received-error normal ?error-message ?error-type)
      (passenger-format-error ?error-type)
      then
      (send-message-with-new-input-role-pairs
       'acknowledge-error ((has-acknowledgement 3)))
      (end-choreography))))))

(def-class vta-error ())

(def-class date-format-error (vta-error))

(def-instance date-format-error date-format-error)

(def-class passenger-format-error (vta-error))

(def-instance passenger-format-error passenger-format-error)

(def-relation GERMAN-BUY-TRAIN-TICKET-upgrade-professor-rule (?choreography ?result))

(def-relation booking-has-professor-upgrade (?string-result ?upgrade-response)
  :prove-by
  (= ?upgrade-response (booking-has-professor-upgrade-response-fun ?string-result)))

(def-function booking-has-professor-upgrade-response-fun (?string-result)
  :lisp-fun
  #'(lambda (string-result)
        (if (string= (string-trim '(#\space #\tab #\return #\linefeed) string-result) 
                     "Free Professor Upgrade Available")
            'professor-upgrade
          'no-upgrade)))

(def-class upgrade-class ())

(def-instance gold-card-upgrade upgrade-class)

(DEF-CLASS UNIVERSAL-TIME-BUY-TRAIN-TICKET-MEDIATION-SERVICE-PUBLISHER-INFORMATION
           (PUBLISHER-INFORMATION)
           ((HAS-ASSOCIATED-WEB-SERVICE-INTERFACE
             :VALUE
             UNIVERSAL-TIME-BUY-TRAIN-TICKET-MEDIATION-SERVICE-INTERFACE)
            (HAS-WEB-SERVICE-HOST :VALUE "137.108.24.200")
            (HAS-WEB-SERVICE-PORT :VALUE 3001)
            (HAS-WEB-SERVICE-LOCATION :VALUE "/soap")))

(DEF-CLASS GERMAN-BUY-TRAIN-TICKET-SERVICE-PUBLISHER-INFORMATION
           (PUBLISHER-INFORMATION)
           ((HAS-ASSOCIATED-WEB-SERVICE-INTERFACE
             :VALUE
             GERMAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-WEB-SERVICE-HOST :VALUE "137.108.24.200")
            (HAS-WEB-SERVICE-PORT :VALUE 3001)
            (HAS-WEB-SERVICE-LOCATION :VALUE "/soap")))

(DEF-CLASS EUROPE-BUSINESS-BUY-TRAIN-TICKET-SERVICE-PUBLISHER-INFORMATION
           (PUBLISHER-INFORMATION)
           ((HAS-ASSOCIATED-WEB-SERVICE-INTERFACE
             :VALUE
             EUROPE-BUSINESS-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-WEB-SERVICE-HOST :VALUE "137.108.24.200")
            (HAS-WEB-SERVICE-PORT :VALUE 3001)
            (HAS-WEB-SERVICE-LOCATION :VALUE "/soap")))

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-PUBLISHER-INFORMATION
           (PUBLISHER-INFORMATION)
           ((HAS-ASSOCIATED-WEB-SERVICE-INTERFACE
             :VALUE
             EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-WEB-SERVICE-HOST :VALUE "137.108.24.200")
            (HAS-WEB-SERVICE-PORT :VALUE 3001)
            (HAS-WEB-SERVICE-LOCATION :VALUE "/soap")))

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-SERVICE-PUBLISHER-INFORMATION
           (PUBLISHER-INFORMATION)
           ((HAS-ASSOCIATED-WEB-SERVICE-INTERFACE
             :VALUE
             ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-WEB-SERVICE-HOST :VALUE "137.108.24.200")
            (HAS-WEB-SERVICE-PORT :VALUE 3001)
            (HAS-WEB-SERVICE-LOCATION :VALUE "/soap")))

(DEF-CLASS FRENCH-BUY-TRAIN-TICKET-SERVICE-PUBLISHER-INFORMATION
           (PUBLISHER-INFORMATION)
           ((HAS-ASSOCIATED-WEB-SERVICE-INTERFACE
             :VALUE
             FRENCH-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-WEB-SERVICE-HOST :VALUE "137.108.24.200")
            (HAS-WEB-SERVICE-PORT :VALUE 3001)
            (HAS-WEB-SERVICE-LOCATION :VALUE "/soap")))

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-PUBLISHER-INFORMATION
           (PUBLISHER-INFORMATION)
           ((HAS-ASSOCIATED-WEB-SERVICE-INTERFACE
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE)
            (HAS-WEB-SERVICE-HOST :VALUE "137.108.24.200")
            (HAS-WEB-SERVICE-PORT :VALUE 3001)
            (HAS-WEB-SERVICE-LOCATION :VALUE "/soap")))

(DEF-CLASS GET-TRAIN-TIMETABLE-SERVICE-PUBLISHER-INFORMATION
           (PUBLISHER-INFORMATION)
           ((HAS-ASSOCIATED-WEB-SERVICE-INTERFACE
             :VALUE
             GET-TRAIN-TIMETABLE-SERVICE-INTERFACE)
            (HAS-WEB-SERVICE-HOST :VALUE "137.108.24.200")
            (HAS-WEB-SERVICE-PORT :VALUE 3001)
            (HAS-WEB-SERVICE-LOCATION :VALUE "/soap")))









(DEF-CLASS TEST-WEB-SERVICE-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             TEST-WEB-SERVICE-NON-FUNC-PROPS)))

(DEF-CLASS TEST-WEB-SERVICE-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE TEST-WEB-SERVICE-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE TEST-WEB-SERVICE-ORCHESTRATION)))





(DEF-CLASS TESTW-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             TESTW-NON-FUNC-PROPS)))

(DEF-CLASS TESTW-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE TESTW-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE TESTW-ORCHESTRATION)))



(DEF-CLASS WS1-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE WS1-NON-FUNC-PROPS)))

(DEF-CLASS WS1-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE WS1-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE WS1-ORCHESTRATION)))





(DEF-CLASS WS3-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE WS3-NON-FUNC-PROPS)))

(DEF-CLASS WS3-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE WS3-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE WS3-ORCHESTRATION)))











(DEF-CLASS W1-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE W1-NON-FUNC-PROPS)))

(DEF-CLASS W1-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE W1-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE W1-ORCHESTRATION)))



(DEF-CLASS WW-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE WW-NON-FUNC-PROPS)))

(DEF-CLASS WW-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE WW-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE WW-ORCHESTRATION)))







(DEF-CLASS WWW-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE WWW-NON-FUNC-PROPS)))

(DEF-CLASS WWW-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE WWW-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE WWW-ORCHESTRATION)))















(DEF-CLASS W3-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE W3-NON-FUNC-PROPS)))

(DEF-CLASS W3-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE W3-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE W3-ORCHESTRATION)))



(DEF-CLASS W2-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE W2-NON-FUNC-PROPS)))

(DEF-CLASS W2-INTERFACE (INTERFACE) ?INTERFACE NIL)



(DEF-CLASS W44-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE W44-NON-FUNC-PROPS)))

(DEF-CLASS W44-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE W44-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE W44-ORCHESTRATION)))



(DEF-CLASS W34-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE W34-NON-FUNC-PROPS)))

(DEF-CLASS W34-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE W34-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE W34-ORCHESTRATION)))



(DEF-CLASS E3-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE E3-NON-FUNC-PROPS)))

(DEF-CLASS E3-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE E3-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE E3-ORCHESTRATION)))



(DEF-CLASS Q1-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE Q1-NON-FUNC-PROPS)))

(DEF-CLASS Q1-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE Q1-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE Q1-ORCHESTRATION)))



(DEF-CLASS W11-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE W11-NON-FUNC-PROPS)))

(DEF-CLASS W11-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE W11-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE W11-ORCHESTRATION)))



(DEF-CLASS W33-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((HAS-NON-FUNCTIONAL-PROPERTIES :VALUE W33-NON-FUNC-PROPS)))

(DEF-CLASS W33-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY :VALUE W33-CHOREOGRAPHY)
            (HAS-ORCHESTRATION :VALUE W33-ORCHESTRATION)))































(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-CAPABILITY-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE-CHOREOGRAPHY
           (CHOREOGRAPHY)
           ((HAS-GROUNDING
             :VALUE
             ((grounded-to-lisp
               (NORMAL BOOK-AUSTRIAN-TRAIN-JOURNEY))))))

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION-PROBLEM-SOLVING-PATTERN
           (PROBLEM-SOLVING-PATTERN)
           NIL)

(DEF-CLASS AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION
           (ORCHESTRATION)
           ((HAS-PROBLEM-SOLVING-PATTERN
             :VALUE
             AUSTRIAN-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION-PROBLEM-SOLVING-PATTERN)))

(DEF-CLASS TEST-MEDIATOR-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

;;(def-relation-mapping get-name has-name has-full-name)

;;(def-class-mapping person1 person2)

#|
(def-rule austrian-cities-rule
  ((city ?x) if
   (official-austrian-city ?x)))

(def-rule austrian-cities-rule
  ((located-in-country ?x ?y) if
   (has-country-location ?x ?y)))
|#



(DEF-CLASS AUSTRIA-CITIES-KB-MEDIATOR-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS AUSTRIA-CITIES-KB-MEDIATOR
           (oo-MEDIATOR)
           ?MEDIATOR
           ((HAS-SOURCE-COMPONENT :VALUE AUSTRIAN-CITIES-KB)
            (HAS-TARGET-COMPONENT :VALUE WSMO-USE-CASE)
            (HAS-MAPPING-RULES
             :VALUE
             (((SYNONYM-MAPPINGS
                ((CHANGE-NAME HEAD-OF-GALWAY CHRISTOPH) IF)
                ((CHANGE-NAME WSML-CITY 'INNSBRUCK) IF)
                ((CHANGE-NAME ?X ?X) IF)))
              ((AUSTRIAN-RELATION-MAPPING
                ((LOCATED-IN-COUNTRY ?X ?Y)
                 IF
                 (HAS-COUNTRY-LOCATION ?X ?Y))))))
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             AUSTRIA-CITIES-KB-MEDIATOR-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS BUY-TRAIN-TICKET-GOAL-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS GERMAN-BUY-TRAIN-TICKET-SERVICE-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS GERMAN-BUY-TRAIN-TICKET-CAPABILITY-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-SERVICE-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-CAPABILITY-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE-CHOREOGRAPHY
           (CHOREOGRAPHY)
           ((HAS-GROUNDING
             :VALUE
             ((GROUNDED-TO-LISP (NORMAL BOOK-ENGLISH-TRAIN-JOURNEY))))))

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION-PROBLEM-SOLVING-PATTERN
           (PROBLEM-SOLVING-PATTERN)
           NIL)

(DEF-CLASS ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION
           (ORCHESTRATION)
           ((HAS-PROBLEM-SOLVING-PATTERN
             :VALUE
             ENGLISH-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION-PROBLEM-SOLVING-PATTERN)))

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-CAPABILITY-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE-CHOREOGRAPHY
           (CHOREOGRAPHY)
           ((HAS-GROUNDING
             :VALUE
             ((GROUNDED-TO-LISP
               (NORMAL BOOK-STUDENT-EUROPEAN-TRAIN-JOURNEY))))))

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION-PROBLEM-SOLVING-PATTERN
           (PROBLEM-SOLVING-PATTERN)
           NIL)

(DEF-CLASS EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION
           (ORCHESTRATION)
           ((HAS-PROBLEM-SOLVING-PATTERN
             :VALUE
             EUROPE-STUDENT-BUY-TRAIN-TICKET-SERVICE-INTERFACE-ORCHESTRATION-PROBLEM-SOLVING-PATTERN)))