;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology aktive-portal-services)

;;;returns the appropriate services
(def-rule aktive-portal-services-rule
  ((has-services ?item (person ?item
                        person-details works-with shares-interests-with 
                        ;;related-stories invite-to
                        current-projects 
                        ;;projects-might-be-interested-in
                        my-planet
                        web-page)) 
   if
   (person ?item))
  ((has-services ?item (publication ?item
                        publication-details related-publications))
   if
   (publication ?item))
  ((has-services ?item (event ?item
                        who what when))
   if
   (event ?item))
  ((has-services ?item (organization ?item
                        competitors same-problem-or-product invite-to 
                        might-fund))
   if
   (organization ?item))
  ((has-services ?item (technology ?item details))
   if
   (technology ?item))
  ((has-services ?item (project ?item project-details project-research-areas 
                                project-publications 
                                ;;related-stories
                                ;;technologies-used
                                resulting-technologies
                                project-members
                                shares-research-areas-with
                                ;;interesting-to
                                my-planet
                                web-page))
   if
   (project ?item))
  ((has-services ?item (research-area ?item related-research-areas 
                        relevant-publications
                        related-stories 
                        related-technologies 
                        related-people
                        related-projects))
   if
   (research-area ?item))
  ((has-services ?item (news-story ?item
                        related-stories related-documents 
                                        related-technologies 
                                        related-people 
                                        related-research-areas))
   if
   (news-story ?item))
  ((has-services ?item (unknown ?item))))

(def-rule aktive-portal-page-service-rule
  ((page-service ?item person person-details)
   if
   (person ?item))
  ((page-service ?item publication publication-details)
   if
   (publication ?item))
  ((page-service ?item event who)
   if
   (event ?item))
  ((page-service ?item organization competitors)
   if
   (organization ?item))
  ((page-service ?item technology details)
   if
   (technology ?item))
  ((page-service ?item project project-details)
   if
   (project ?item))
  ((page-service ?item research-area related-research-areas)
   if
   (research-area ?item))
  ((page-service ?item news-story related-stories)
   if
   (news-story ?item)))


(def-rule akt-portal-has-web-address2-rule
    ((has-web-address2 ?x ?url)
     if
     (has-web-address ?x ?url) cut)
    ((has-web-address2 ?x nil)))