;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology bravoairservice)
#|
(def-class BravoAir_Process (composite-owls-service) ?psm
  ((has-input-role :value DepartureAirport_In
                   :value ArrivalAirport_In
                   :value OutboundDate_In
                   :value InboundDate_In
                   :value RoundTrip_In
                   :value PreferredFlightItinerary_In
                   :value ReservationID_In
                   :value Confirm_In)
   (DepartureAirport_In :type Airport)
   (ArrivalAirport_In :type Airport)
   (OutboundDate_In :type FlightDate)
   (InboundDate_In :type FlightDate)
   (RoundTrip_In :type RoundTrip)
   (PreferredFlightItinerary_In :type FlightItinerary)
   (ReservationID_In :type ReservationNumber)
   (Confirm_In :type Confirmation)
   (has-output-role :value AvailableFlightItineraryList_Out
                    :value PreferredFlightItinerary_Out
                    :value AcctName_Out
                    :value ReservationID_Out)
   (AvailableFlightItineraryList_Out :type FlightItineraryList)
   (PreferredFlightItinerary_Out :type FlightItinerary)
   (AcctName_Out :type AcctName)
   (ReservationID_Out :type ReservationNumber)
   (has-profile Profile_BravoAir_ReservationAgent)
    (has-body
     :value
     '(lambda (?psm)
      (in-environment
        ((?dummy-out0 .
          (achieve-generic-subtask
                  ?psm GetDesiredFlightDetails
                  'DepartureAirport_In (role-value ?psm DepartureAirport_In)
                  'ArrivalAirport_In (role-value ?psm ArrivalAirport_In)
                  'OutboundDate_In (role-value ?psm OutboundDate_In)
                  'InboundDate_In (role-value ?psm InboundDate_In)
                  'RoundTrip_In (role-value ?psm RoundTrip_In)))
         (?AvailableFlightItineraryList_Out .
          (achieve-generic-subtask
                  ?psm SelectAvailableFlight
                  'PreferredFlightItinerary_In (role-value ?psm PreferredFlightItinerary_In)))
         (?PreferredFlightItinerary_Out ?AcctName_Out ?ReservationID_Out .
          (achieve-generic-subtask
                  ?psm BookFlight
                  'ReservationID_In (role-value ?psm ReservationID_In)
                  'Confirm_In (role-value ?psm Confirm_In)))))))))



(def-class GetDesiredFlightDetails (atomic-owls-service) ?psm
  ((has-input-role :value DepartureAirport_In
                   :value ArrivalAirport_In
                   :value OutboundDate_In
                   :value InboundDate_In
                   :value RoundTrip_In)
   (DepartureAirport_In :type Airport)
   (ArrivalAirport_In :type Airport)
   (OutboundDate_In :type FlightDate)
   (InboundDate_In :type FlightDate)
   (RoundTrip_In :type RoundTrip)))



(def-class SelectAvailableFlight (atomic-owls-service) ?psm
  ((has-input-role :value PreferredFlightItinerary_In)
   (PreferredFlightItinerary_In :type FlightItinerary)
   (has-output-role :valueAvailableFlightItineraryList_Out)
   (AvailableFlightItineraryList_Out :type FlightItineraryList)))



(def-class BookFlight (composite-owls-service) ?psm
  ((has-input-role :value ReservationID_In
                   :value Confirm_In)
   (ReservationID_In :type ReservationNumber)
   (Confirm_In :type Confirmation)
   (has-output-role :valuePreferredFlightItinerary_Out
                    :value AcctName_Out
                    :value ReservationID_Out)
   (PreferredFlightItinerary_Out :type FlightItinerary)
   (AcctName_Out :type AcctName)
   (ReservationID_Out :type ReservationNumber)    (has-body
     :value
     '(lambda (?psm)
      (in-environment
        ((?dummy-out0 .
          (achieve-generic-subtask
                  ?psm Login))
         (?PreferredFlightItinerary_Out ?AcctName_Out ?ReservationID_Out .
          (achieve-generic-subtask
                  ?psm ConfirmReservation
                  'ReservationID_In (role-value ?psm ReservationID_In)
                  'Confirm_In (role-value ?psm Confirm_In)))))))))



(def-class Login (atomic-owls-service) ?psm
  ())



(def-class ConfirmReservation (atomic-owls-service) ?psm
  ((has-input-role :value ReservationID_In
                   :value Confirm_In)
   (ReservationID_In :type ReservationNumber)
   (Confirm_In :type Confirmation)
   (has-output-role :valuePreferredFlightItinerary_Out
                    :value AcctName_Out
                    :value ReservationID_Out)
   (PreferredFlightItinerary_Out :type FlightItinerary)
   (AcctName_Out :type AcctName)
   (ReservationID_Out :type ReservationNumber)
   (has-postcondition :valueHaveSeat)))


(def-class Airport ()

)



(def-class FlightDate ()

)



(def-class RoundTrip ()

)



(def-class FlightItinerary ()

)



(def-class ReservationNumber ()

)



(def-class Confirmation ()

)



(def-class FlightItineraryList ()

)



(def-class AcctName ()

)



(def-instance Profile_BravoAir_ReservationAgent AirlineTicketing

 (   (presentedBy BravoAir_ReservationAgent )

   (has_process BravoAir_Process )

   (serviceName BravoAir_ReservationAgent )

   (textDescription 
	This  service provide flight reservations based on the
	specification of a flight request.  This typically involves a departure
	airport, an arrival airport, a departure date, and if a return trip is
	required, a return date.
        If the desired flight is available, an itinerary and reservation number
	will be returned.
     )

   (contactInformation (BravoAir-reservation BravoAir-information ))

   (serviceParameter BravoAir-geographicRadius )

   (qualityRating BravoAir-goodRating )

   (serviceCategory (NAICS-category UNSPSC-category ))

   (hasInput (DepartureAirport_In ArrivalAirport_In OutboundDate_In InboundDate_In RoundTrip_In PreferredFlightItinerary_In AcctName_In Password_In ReservationID_In Confirm_In ))

   (hasOutput (AvailableFlightItineraryList_Out PreferredFlightItinerary_Out AcctName_Out ReservationID_Out ))

   (hasEffect HaveSeat ))

)



(def-instance BravoAir-reservation Actor

 (   (name BravoAir Reservation department )

   (title 
	  Reservation Representative 
	 )

   (phone 412 268 8780  )

   (fax 412 268 5569  )

   (email Bravo@Bravoair.com )

   (physicalAddress 
	      Airstrip 2,
	      Teetering Cliff Hights,
	      Florida 12321,
	      USA
	 )

   (webURL  
            http://www.daml.org/services/daml-s/2001/05/BravoAir.html 
         ))

)



(def-instance BravoAir-information Actor

 (   (name John Doe )

   (title Sale Representative )

   (phone 412 268 8789  )

   (fax 412 268 5569  )

   (email John_Doe@Bravoair.com )

   (physicalAddress 
	      Airstrip 2,
	      Teetering Cliff Hights,
	      Florida 12321,
	      USA
	 )

   (webURL  
            http://www.daml.org/services/daml-s/2001/05/BravoAir.html 
         ))

)



(def-instance BravoAir-geographicRadius GeographicRadius

 (   (serviceParameterName 
	  BravoAir Geographic Radius
	 )

   (sParameter UnitedStates ))

)



(def-instance BravoAir-goodRating QualityRating

 (   (ratingName 
	  SomeRating
	 )

   (rating GoodRating ))

)



(def-instance NAICS-category NAICS

 (   (value 
	  Airline reservation services 
	 )

   (code 
	  561599
	 ))

)



(def-instance UNSPSC-category UNSPSC

 (   (value 
	  Travel Agent
	 )

   (code 
	  90121500
	 ))

)





(def-instance bar foo)

(def-instance bar ffoo)
|#

