;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology document-analysis-psm-ontology)


(def-class convert-pdf-to-html-psm (primitive-method) ?psm
  ((has-input-role :value has-url
                   :value
                   has-input-document-type
                   :value
                   has-output-document-type)
   (has-output-role :value has-converted-document-url)
   (has-url :type url)
   (has-input-document-type :type document-type)
   (has-output-document-type :type document-type)
   (has-converted-document-url :type url))
  :own-slots
  ((applicability-condition
    (kappa
     (?task)
     (and (pdf-document-type
           (role-value ?task 'has-input-document-type))
          (html-document-type
           (role-value ?task 'has-output-document-type)))))
   (tackles-task-type convert-document-task)))











(def-class extract-items-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-url :value has-ontology)
            (has-output-role :value has-document-items)
            (has-url :type url)
            (has-ontology :type ontology)
            (has-document-items :type list))
           :own-slots
           ((tackles-task-type extract-items-task)))


(def-class classify-paper-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-url :value has-format)
            (has-output-role :value classification)
            (has-url :type has-url)
            (has-format :type symbol)
            (classification :type string))
           :own-slots
           ((tackles-task-type classify-paper-task)))

(def-class analyse-document-psm
           (primitive-method)
           ?psm
           ((has-input-role
             :value
             has-url
             :value
             has-document-type
             :value
             has-ontology)
            (has-output-role :value has-analysis)
            (has-url :type url)
            (has-document-type :type document-type)
            (has-ontology :type ontology)
            (has-analysis :type string))
           :own-slots
           ((tackles-task-type analyse-document-task)))



(def-class convert-x-to-x-psm
           (primitive-method)
           ?psm
           ((has-input-role
             :value
             has-url
             :value
             has-input-document-type
             :value
             has-output-document-type)
            (has-output-role :value has-converted-document-url)
            (has-url :type url)
            (has-input-document-type :type document-type)
            (has-output-document-type :type document-type)
            (has-converted-document-url :type url))
           :own-slots
           ((applicability-condition
             (kappa
              (?task)
              (= (role-value ?task 'has-input-document-type)
                 (role-value ?task 'has-output-document-type))))
            (tackles-task-type convert-document-task)))

(def-class convert-html-to-pdf-psm
           (primitive-method)
           ?psm
           ((has-input-role
             :value
             has-url
             :value
             has-input-document-type
             :value
             has-output-document-type)
            (has-output-role :value has-converted-document-url)
            (has-url :type url)
            (has-input-document-type :type document-type)
            (has-output-document-type :type document-type)
            (has-converted-document-url :type url))
           :own-slots
           ((applicability-condition
             (kappa
              (?task)
              (and (html-document-type
                    (role-value ?task 'has-input-document-type))
                   (pdf-document-type
                    (role-value ?task 'has-output-document-type)))))
            (tackles-task-type convert-document-task)))

(def-class convert-html-to-ps-psm
           (primitive-method)
           ?psm
           ((has-input-role
             :value
             has-url
             :value
             has-input-document-type
             :value
             has-output-document-type)
            (has-output-role :value has-converted-document-url)
            (has-url :type url)
            (has-input-document-type :type document-type)
            (has-output-document-type :type document-type)
            (has-converted-document-url :type url))
           :own-slots
           ((applicability-condition kappa)
            (tackles-task-type convert-document-task)))







(def-class test1-psm
           (primitive-method)
           ?psm
           ((has-input-role :value input1)
            (has-output-role :value output1)
            (input1 :type number)
            (output1 :type number))
           :own-slots
           ((tackles-task-type test1)))

(def-class test1
           (goal-specification-task)
           ?task
           ((has-input-role :value input1)
            (has-output-role :value output1)
            (input1 :type number)
            (output1 :type number)))

(def-irs-soap-bindings test1
                       document-analysis-psm-ontology
                       ((input1 "sexpr"))
                       "sexpr")