;;; Mode: Lisp; Package: ocml

;;; The Open University

(in-package "OCML")


(in-ontology ExchangeRateProvider)


(def-class exchange_rate_provider (primitive-method) ?psm
  ((has-input-role :value has_source_currency 
                   :value has_target_currency
                   )
   (has-output-role :value has_exchange_rate)
   (has_source_currency :type currency :cardinality 1)
   (has_target_currency :type currency :cardinality 1)
   (has_exchange_rate :type positive-number)
   (has-precondition 
    :value (kappa (?psm)
                  (and (currency (role-value ?psm has_source_currency))
                       (currency (role-value ?psm has_target_currency)))))
   (has-postcondition 
    :value (kappa (?psm ?sol)
                  (= ?sol (the_exchange_rate (role-value ?psm has_source_currency)
                                             (role-value ?psm has_target_currency)))))
  ;; (has-body :value (lambda (?psm)
  ;;                    (the_exchange_rate (role-value ?psm has_source_currency)
 ;;                                            (role-value ?psm has_target_currency))))
)
  :own-slots ((tackles-task-type  exchange_rate_provision)))
