;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology miakt-matching-psm)

(def-class find-abnos-matching-abno-by-overall-impression-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-abnormality)
            (has-output-role :value all-similar-abnormalities)
            (has-abnormality :type abnormality)
            (all-similar-abnormalities :type list))
           :own-slots
           ((tackles-task-type
             find-abnos-matching-abno-by-overall-impression-task)))

(def-class find-abnos-matching-abno-by-finding-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-abnormality)
            (has-output-role :value all-similar-abnormalities)
            (has-abnormality :type abnormality)
            (all-similar-abnormalities :type list))
           :own-slots
           ((tackles-task-type
             find-abnos-matching-abno-by-finding-task)))

(def-class find-abnos-matching-abno-by-same-morpho-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-abnormality)
            (has-output-role :value all-similar-abnormalities)
            (has-abnormality :type abnormality)
            (all-similar-abnormalities :type list))
           :own-slots
           ((tackles-task-type
             find-abnos-matching-abno-by-same-morpho-task)))

(def-class find-images-matching-image-by-entity-lateral-view-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-mammo-image)
            (has-output-role :value all-similar-images)
            (has-mammo-image :type mammo_image)
            (all-similar-images :type list))
           :own-slots
           ((tackles-task-type
             find-images-matching-image-by-entity-lateral-view-task)))

(def-class find-images-matching-image-by-lateral-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-mammo-image)
            (has-output-role :value all-similar-images)
            (has-mammo-image :type mammo_image)
            (all-similar-images :type list))
           :own-slots
           ((tackles-task-type
             find-images-matching-image-by-lateral-task)))

(def-class find-images-matching-image-by-view-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-mammo-image)
            (has-output-role :value all-similar-images)
            (has-mammo-image :type mammo_image)
            (all-similar-images :type list))
           :own-slots
           ((tackles-task-type
             find-images-matching-image-by-view-task)))

(def-class find-metarois-matching-metaroi-by-distribution-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-metaroi)
            (has-output-role :value all-similar-metarois)
            (has-metaroi :type meta_r-o-i)
            (all-similar-metarois :type list))
           :own-slots
           ((tackles-task-type
             find-metarois-matching-metaroi-by-distribution-task)))

(def-class find-patients-matching-patient-by-age-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-patient)
            (has-output-role :value all-similar-patients)
            (has-patient :type patient)
            (all-similar-patients :type list))
           :own-slots
           ((tackles-task-type
             find-patients-matching-patient-by-age-task)))

(def-class find-taps-matching-tap-by-patient-age-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-triple-assessment-proc)
            (has-output-role :value all-similar-taps)
            (has-triple-assessment-proc :type triple_assessment_proc)
            (all-similar-taps :type list))
           :own-slots
           ((tackles-task-type
             find-taps-matching-tap-by-patient-age-task)))

(def-class find-taps-matching-tap-by-lateral-image-view-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-triple-assessment-proc)
            (has-output-role :value all-similar-taps)
            (has-triple-assessment-proc :type triple_assessment_proc)
            (all-similar-taps :type list))
           :own-slots
           ((tackles-task-type
             find-taps-matching-tap-by-lateral-image-view-task)))

(def-class find-images-matching-image-by-morpho-feature-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-mammo-image)
            (has-output-role :value all-similar-images)
            (has-mammo-image :type mammo_image)
            (all-similar-images :type list))
           :own-slots
           ((tackles-task-type
             find-images-matching-image-by-morpho-feature-task)))

(def-class find-images-matching-image-by-is-finding-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-mammo-image)
            (has-output-role :value all-similar-images)
            (has-mammo-image :type mammo_image)
            (all-similar-images :type list))
           :own-slots
           ((tackles-task-type
             find-images-matching-image-by-is-finding-task)))

(def-class find-image-files-matching-patient-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-patient)
            (has-output-role :value image-files)
            (has-patient :type patient)
            (image-files :type string))
           :own-slots
           ((tackles-task-type find-image-files-matching-patient-task)))

(def-class find-images-matching-patient-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-patient)
            (has-output-role :value images)
            (has-patient :type patient)
            (images :type list))
           :own-slots
           ((tackles-task-type find-images-matching-patient-task)))

(def-class find-image-files-matching-abno-by-finding-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-abnormality)
            (has-output-role :value image-files)
            (has-abnormality :type abnormality)
            (image-files :type string))
           :own-slots
           ((tackles-task-type
             find-image-files-matching-abno-by-finding-task)))

(def-class find-image-files-matching-abno-by-overall-impression-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-abnormality)
            (has-output-role :value image-files)
            (has-abnormality :type abnormality)
            (image-files :type string))
           :own-slots
           ((tackles-task-type
             find-image-files-matching-abno-by-overall-impression-task)))

(def-class find-images-matching-abno-by-overall-impression-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-abnormality)
            (has-output-role :value images)
            (has-abnormality :type abnormality)
            (images :type list))
           :own-slots
           ((tackles-task-type
             find-images-matching-abno-by-overall-impression-task)))

(def-class find-images-matching-abno-by-finding-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-abnormality)
            (has-output-role :value images)
            (has-abnormality :type abnormality)
            (images :type list))
           :own-slots
           ((tackles-task-type
             find-images-matching-abno-by-finding-task)))

(def-class find-images-matching-abno-generic-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-abnormality)
            (has-output-role :value images)
            (has-abnormality :type abnormality)
            (images :type string))
           :own-slots
           ((tackles-task-type find-images-matching-abno-generic-task)))

(def-class find-image-files-matching-abno-generic-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-abnormality)
            (has-output-role :value images)
            (has-abnormality :type abnormality)
            (images :type string))
           :own-slots
           ((tackles-task-type
             find-image-files-matching-abno-generic-task)))