;;; -*- Mode: LISP; Syntax: Common-lisp; Base: 10; Package: OCML;   -*-

(in-package "OCML")


(in-ontology propose-and-revise)

(def-class PROPOSE&REVISE (design-method)
  ((has-input-role :value has-design-fixes 
                   :value has-design-procedures)
   (has-design-procedures :type design-procedure)
   (has-design-fixes :type design-fix))
  :lisp-class-name propose&revise)

(def-class CMR (PROPOSE&REVISE)
  :lisp-class-name cmr)


(def-class FIXABLE-PARAMETRIC-CONSTRAINT (parametric-constraint) ?x
  "A fixable parametric constraint is a parametric constraint which
   can be fixed by some relevant design fixes"
  :iff-def (exists ?f (and (design-fix ?f)
                           (member ?x (the ?l 
                                        (applicable-to-constraints ?f ?l)))))
  :Lisp-slots ((relevant-operators :accessor relevant-operators
                                   :initform nil))
  :lisp-class-name  FIXABLE-PARAMETRIC-CONSTRAINT)


(def-class DESIGN-PROCEDURE (design-extension-operator)
   :lisp-class-name design-procedure)

(def-class DESIGN-FIX (design-modification-operator)
  "A basic design fix is a basic design modification operator which is associated
   with a fixable parametric constraint"
  ((applicable-to-constraints :type function-expression
                              :documentation "An expression which returns the set
                                              of constraints which can be fixed by 
                                              this fix"))
  :lisp-slots ((effective-constraint-list 
                                         :initform nil
                                         :accessor effective-constraint-list))
   :lisp-class-name design-fix)


(def-class BASIC-DESIGN-PROCEDURE (design-procedure basic-design-extension-operator)
  "Essentially another name for a basic design extension operator"
   :lisp-class-name basic-design-procedure)

(def-class MULTIPLE-DESIGN-PROCEDURE (design-procedure 
                                          multiple-design-extension-operator)
  "Essentially another name for a multiple design extension operator"
   :lisp-class-name multiple-design-procedure)



(def-class BASIC-DESIGN-FIX (design-fix basic-design-modification-operator)
  "A basic design fix is a basic design modification operator which is associated
   with a fixable parametric constraint"
  :lisp-class-name basic-design-fix)

(def-class multiple-DESIGN-FIX (design-fix 
                                    multiple-design-modification-operator)
  "A multiple design fix is a multiple design modification operator 
   which is associated with a fixable parametric constraint"
  :lisp-class-name multiple-design-fix)