package org.infrawebs.axiom.editor;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.gef.Request;
import org.eclipse.gef.dnd.AbstractTransferDropTargetListener;
import org.eclipse.gef.dnd.TemplateTransfer;
import org.eclipse.gef.requests.CreateRequest;
import org.infrawebs.axiom.model.ModelFactory;
import org.infrawebs.axiom.plugin.AxiomEditorPlugin;
import org.omwg.ontology.OntologyElement;

public class OntologyTransferDropTargetListener extends
		AbstractTransferDropTargetListener {

	public OntologyTransferDropTargetListener(EditPartViewer viewer, Transfer xfer) {
		super(viewer, xfer);
	}

	public OntologyTransferDropTargetListener(EditPartViewer viewer) {
		super(viewer, TemplateTransfer.getInstance());
	}

	@Override
	protected void updateTargetRequest() {
		((CreateRequest)getTargetRequest()).setLocation(getDropLocation());
	}

	@Override
	protected Request createTargetRequest() {
		CreateRequest request = new CreateRequest();
		request.setFactory(AxiomEditorPlugin.getAxiomContentsModel().getFactory());
		return request;
	}

// prevent the source from deletion	
//	protected void handleDragOver() {
//		getCurrentEvent().detail = DND.DROP_COPY;
//		super.handleDragOver();
//	}
	
	@Override
	protected void handleDrop() {
		Object item = getCurrentEvent().data;
		ModelFactory factory = AxiomEditorPlugin.getAxiomContentsModel().getFactory();
		factory.setSeed(item instanceof OntologyElement ? (OntologyElement)item : null);
		super.handleDrop();
	}	

}
