package org.infrawebs.axiom.editor.actions.contents;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.editor.actions.ontology.SelectFromOntologyAction;
import org.infrawebs.axiom.model.AbstractModel;
import org.infrawebs.axiom.model.AxiomContentsModel;
import org.infrawebs.axiom.model.AxiomRootModel;
import org.infrawebs.axiom.model.ModelWithConnections;
import org.infrawebs.axiom.operations.ModelOperations;
import org.infrawebs.ontology.ui.OntoImages;
import org.infrawebs.ontology.OntoFilter;
import org.omwg.ontology.OntologyElement;

public class CreateRelationAction extends SelectFromOntologyAction
{
	public CreateRelationAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		AbstractModel model = this.getSelectedModel();
		return (model instanceof AxiomContentsModel ||
				model instanceof AxiomRootModel);
	}

	@Override
	protected String getCaption() {
		return "Add a relation";
	}

	@Override
	protected Image getImage() {
		return OntoImages.getImage(OntoImages.RELATION);
	}

	@Override
	protected String getSelectionDialogTitle() {
		return "Please, select a relation.";
	}

	@Override
	protected OntoFilter createOntoFilter() {
		OntoFilter ontoFilter = new OntoFilter(false);
		ontoFilter.showRelations = true;
		ontoFilter.selectRelations = true;
		return ontoFilter;
	}

	@Override
	protected void onOkPressed(OntologyElement ontologyElement) {
		ModelWithConnections model = getContentsModel().getFactory().createAxiomElement(ontologyElement);
		ModelOperations.createAndConnectToAxiomRoot(model);
	}
}
