package org.infrawebs.axiom.editor.actions.operators;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.operations.SemanticConsistence;
import org.infrawebs.ontology.ui.OntoImages;
import org.infrawebs.ontology.OntoFilter;

public class AddOperandCustomTypeValueInstanceAction extends AddOperandCustomTypeAction
{
	public AddOperandCustomTypeValueInstanceAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		// Show action only for refinables of WSML built-in types and their subtypes.
		return super.calculateVisible() && SemanticConsistence.isValueType(this.chainOrigin);
	}

	@Override
	protected String getCaption() {
		return "Add a custom type value instance operand...";
	}

	@Override
	protected Image getImage() {
		return OntoImages.getImage(OntoImages.INSTANCE);
	}

	@Override
	protected String getSelectionDialogTitle() {
		return "Please, select a type for the variable. The type is always a concept.";
	}

	@Override
	protected OntoFilter createOntoFilter() {
		OntoFilter ontoFilter = super.createOntoFilter();
		ontoFilter.showConcepts = true;
		ontoFilter.showAttributes = true;
		ontoFilter.selectConcepts = true;
		return ontoFilter;
	}
	
}
