package org.infrawebs.axiom.editor.actions.refinables;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.model.RefinableModel;
import org.infrawebs.axiom.operations.SemanticConsistence;
import org.infrawebs.ontology.ui.OntoImages;
import org.infrawebs.ontology.OntoFilter;

public class RefineByCustomTypeValueInstanceAction extends RefineByCustomTypeAction
{
	public RefineByCustomTypeValueInstanceAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		// Show action only for refinables of WSML built-in types and their subtypes.
		return super.calculateVisible() &&
				SemanticConsistence.isValueType((RefinableModel)getSelectedModel());
	}
	
	@Override
	protected String getCaption() {
		return "Refine by a custom type value instance...";
	}

	@Override
	protected Image getImage() {
		return OntoImages.getImage(OntoImages.INSTANCE);
	}

	@Override
	protected String getSelectionDialogTitle() {
		return "Please, select a type for the value instance. The type is always a concept.";
	}

	@Override
	protected OntoFilter createOntoFilter() {
		OntoFilter ontoFilter = super.createOntoFilter();
		ontoFilter.showConcepts = true;
		ontoFilter.showAttributes = true;
		ontoFilter.selectConcepts = true;
		return ontoFilter;
	}
	
}
