package org.infrawebs.axiom.editor.actions.refinables;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.model.RefinableModel;
import org.infrawebs.axiom.operations.SemanticConsistence;
import org.infrawebs.ontology.ui.OntoImages;

public class RefineByDefaultTypeValueInstanceAction extends RefineByDefaultTypeAction
{
	public RefineByDefaultTypeValueInstanceAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		// Show action only for refinables of WSML built-in types and their subtypes.
		return super.calculateVisible() &&
				SemanticConsistence.isValueType((RefinableModel)getSelectedModel());
	}
	
	@Override
	protected String getCaption() {
		return "Refine by a default type value instance";
	}

	@Override
	protected Image getImage() {
		return OntoImages.getImage(OntoImages.INSTANCE);
	}

}
