package org.infrawebs.axiom.editor.editparts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.widgets.Text;

public class AxiomCellEditorLocator implements CellEditorLocator
{
	private IFigure figure;

	public AxiomCellEditorLocator(IFigure figure) {
		this.figure = figure;
	}

	public void relocate(CellEditor celleditor) {
		Text text = (Text)celleditor.getControl();
		text.computeSize(-1, -1);
		Rectangle rect = this.figure.getBounds().getCopy();
		this.figure.translateToAbsolute(rect);
		text.setBounds(rect.x, rect.y, rect.width, rect.height);
	}
	
	public IFigure getFigure() {
		return this.figure;
	}
}
