package org.infrawebs.axiom.editor.editparts;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.infrawebs.axiom.model.AbstractModel;

abstract public class AxiomEditPart extends AbstractGraphicalEditPart
		implements PropertyChangeListener {

	@Override
	protected void refreshVisuals() {
		AbstractModel model = (AbstractModel)getModel();
		GraphicalEditPart parent = (GraphicalEditPart)getParent(); 
		parent.setLayoutConstraint(this, getFigure(), model.getConstraint());
	}

	public void propertyChange(PropertyChangeEvent evt) {
		if (evt.getPropertyName().equals(AbstractModel.ID_PROPERTY_CONSTRAINT)) {
			refreshVisuals();
		}
	}

	@Override
	public void activate() {
		super.activate();
		((AbstractModel)getModel()).addPropertyChangeListener(this);
	}

	@Override
	public void deactivate() {
		((AbstractModel)getModel()).removePropertyChangeListener(this);
		super.deactivate();
	}

	/**
	 * Removes a child edit part and lets the parent regenerate it.
	 * Should be used as a last resort when changing the figure of an
	 * edit part. If the old figure is too different from the new
	 * figure it is easier to just create the new figure from scratch.  
	 */
	public void rebuildChild(AxiomEditPart child) {
		removeChild(child);
		refreshChildren();
	}

}
