package org.infrawebs.axiom.editor.editparts;

import java.beans.PropertyChangeEvent;
import java.util.List;

import org.eclipse.draw2d.ChopboxAnchor;
import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.gef.ConnectionEditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.NodeEditPart;
import org.eclipse.gef.Request;
import org.infrawebs.axiom.editor.editpolicies.AxiomGraphicalNodeEditPolicy;
import org.infrawebs.axiom.model.ModelWithConnections;

public abstract class EditPartWithConnections extends AxiomEditPart
		implements NodeEditPart {

	@Override
	protected void createEditPolicies() {
		// Takes care of reconnecting nodes.
		installEditPolicy(EditPolicy.GRAPHICAL_NODE_ROLE, new AxiomGraphicalNodeEditPolicy());
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		if (evt.getPropertyName().equals(ModelWithConnections.ID_PROPERTY_SOURCE_CONNECTION)) {
			refreshSourceConnections();
		}
		else if (evt.getPropertyName().equals(ModelWithConnections.ID_PROPERTY_TARGET_CONNECTION)) {
			refreshTargetConnections();
		}
		else {
			super.propertyChange(evt);
		}
	}

	public ConnectionAnchor getSourceConnectionAnchor(ConnectionEditPart connection) {
		return new ChopboxAnchor(getFigure());
	}

	public ConnectionAnchor getTargetConnectionAnchor(ConnectionEditPart connection) {
		return new ChopboxAnchor(getFigure());
	}

	public ConnectionAnchor getSourceConnectionAnchor(Request request) {
		return new ChopboxAnchor(getFigure());
	}

	public ConnectionAnchor getTargetConnectionAnchor(Request request) {
		return new ChopboxAnchor(getFigure());
	}

	@Override
	protected List getModelSourceConnections() {
		if (getModel() instanceof ModelWithConnections) {
			return ((ModelWithConnections)getModel()).listSourceConnections();
		}
		return null;
	}

	@Override
	protected List getModelTargetConnections() {
		if (getModel() instanceof ModelWithConnections) {
			return ((ModelWithConnections)getModel()).listTargetConnections();
		}
		return null;
	}
}
