package org.infrawebs.axiom.editor.editparts;

import org.eclipse.draw2d.IFigure;
import org.infrawebs.axiom.editor.figures.InstanceFigure;
import org.infrawebs.axiom.model.InstanceModel;
import org.infrawebs.axiom.plugin.AxiomEditorPlugin;

public class InstanceEditPart extends MemberOfEditPart {
	
	@Override
	protected IFigure createFigure() {
		InstanceModel model = (InstanceModel)getModel();
		return new InstanceFigure(
				AxiomEditorPlugin.ontoStore.getPrefixedName(model.getConcept()),
				model.getValue(),
				model.getVarNameModel().getExistsFlag(),
				model.isCompact());
	}
	
	@Override
	public String getDirectEditText() {
		return null;
	}

	@Override
	public void setDirectEditText(String text) {
		// No direct edit part is supported for ontology instances.
	}

}
