package org.infrawebs.axiom.editor.editparts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.swt.graphics.Color;
import org.infrawebs.axiom.editor.editpolicies.ToolbarLayoutEditPolicyImpl;
import org.infrawebs.axiom.editor.figures.ListFigure;
import org.infrawebs.axiom.model.Compactable;
import org.infrawebs.axiom.model.RefinableListModel;

public abstract class RefinableListEditPart extends ContainerEditPart
{
	@Override
	public IFigure createFigure() {
		RefinableListModel model = (RefinableListModel)getModel();
		boolean isCompact = ((Compactable)model.getOwner()).isCompact();
		ListFigure localFigure = new ListFigure(getTitle(),
				getBackColor(), isCompact);
		return localFigure;
	}
	
	@Override
	public void createEditPolicies() {
		installEditPolicy(EditPolicy.LAYOUT_ROLE, new ToolbarLayoutEditPolicyImpl());
	}
	
	protected abstract String getTitle();
	protected abstract Color getBackColor();

}
