package org.infrawebs.axiom.editor.editparts;


import java.beans.PropertyChangeEvent;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.infrawebs.axiom.editor.figures.VarNameFigure;
import org.infrawebs.axiom.model.VarNameModel;

public class VarNameEditPart extends DirectEditEditPart
{
	@Override
	public IFigure createFigure()
	{
		VarNameModel model = (VarNameModel)getModel();
		return new VarNameFigure(model.getName(), model.getExistsFlag());
	}
	
	@Override
	public String getDirectEditText() {
		return ((Label)getFigure()).getText();
	}

	@Override
	public void setDirectEditText(String text) {
		((Label)getFigure()).setText(text);
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		super.propertyChange(evt);
		
		if (evt.getPropertyName().equals(VarNameModel.ID_PROPERTY_VARNAME)) {
			((Label)getFigure()).setText((String)evt.getNewValue());
		}
	}
	
}
