package org.infrawebs.axiom.editor.figures;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.Label;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.infrawebs.axiom.settings.ColorSettings;
import org.infrawebs.axiom.settings.FontSettings;
import org.infrawebs.ontology.ui.OntoImages;

public class InstanceFigure extends MemberOfFigure
{
	protected Label valueLabel = null;
	
	public InstanceFigure(String variableType,
			String value, boolean existsFlag, boolean isCompact) {
		super(variableType, "", existsFlag, isCompact);
		
		this.varNameFigure.setVisible(false);
		
			// valueLabel
			this.valueLabel = new Label();
			this.valueLabel.setText(value);
			this.valueLabel.setBackgroundColor(ColorSettings.CONSTANT_VALUE_BACK);
			this.valueLabel.setFont(FontSettings.CONSTANT_VALUE);
			this.valueLabel.setOpaque(true);

		// display the value in the bodyPanel		
		this.bodyPanel.add(this.valueLabel, BorderLayout.CENTER);

// .....HyperLinkLabel experiments.....
//	    HyperLinkLabel linkLabel = new HyperLinkLabel("INFRAWEBS");
//	    linkLabel.addActionListener(new ActionListener() {
//	    	public void actionPerformed(ActionEvent event) {
//	    		Messages.Show("aa", "bb");
//	    	}
//	    });
//	    linkLabel.addMouseMotionListener(new MouseMotionListener.Stub() {
//	      public void mouseEntered(MouseEvent me) {
//	        AxiomEditorPlugin.getDefault().getWorkbench().
//				getActiveWorkbenchWindow().getShell().
//				setText("entered");
//	      }
//
//	      public void mouseExited(MouseEvent me) {
//	        AxiomEditorPlugin.getDefault().getWorkbench().
//			getActiveWorkbenchWindow().getShell().
//	        setText("exited");
//	      }
//	    });
//
//	    Panel tooltip = new Panel() {
//	      protected void paintFigure(Graphics graphics) {
//	        graphics.fillGradient(getBounds(), false);
//	      }
//	    };
//	    tooltip.setLayoutManager(new StackLayout());
//	    tooltip.setBackgroundColor(ColorConstants.lightGreen);
//	    tooltip.setForegroundColor(ColorConstants.cyan);
//
//	    Label label = new Label("Web ?????????");
//	    label.setForegroundColor(ColorConstants.darkBlue);
//	    tooltip.add(label);
//
//	    linkLabel.setToolTip(tooltip);	    
//	    
//	    bodyPanel.add(linkLabel, BorderLayout.BOTTOM);
	}

	@Override
	public void setCompact(boolean isCompact) {
		super.setCompact(isCompact);
		// When in compact mode, move the Instance icon to the top-left
		// corner so that it is visible.
		this.headerPanel.setConstraint(this.conceptLabel,
				isCompact ? BorderLayout.LEFT : BorderLayout.CENTER);
	}
	
	@Override
	public Color getHeaderColorEnabled() {
		return ColorSettings.INSTANCE_HEADER_BACK;
	}

	@Override
	public Color getHeaderColorDisabled() {
		return ColorSettings.INSTANCE_HEADER_BACK_DISABLED;
	}

	@Override
	public Image getIconEnabled() {
		return OntoImages.getImage(OntoImages.INSTANCE);
	}
	
	@Override
	public Image getIconDisabled() {
		return OntoImages.getImage(OntoImages.INSTANCE_DISABLED);
	}
	
	public void setValue(String value) {
		this.valueLabel.setText(value);
	}

}
