package org.infrawebs.axiom.editor.figures;

import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.*;
import org.eclipse.swt.graphics.Color;
import org.infrawebs.axiom.model.Compactable;

public class ListFigure extends Figure implements Compactable
{
	private static final Dimension minimumSize = new Dimension(0, 0);
	
	private ListFigureBorder localBorder = null;
	private boolean isCompact;
	
	public ListFigure(String label, Color color, boolean isCompact) {
		super();
		this.localBorder = new ListFigureBorder();
		this.localBorder.setLabel(label);
		this.localBorder.setColor(color);
		setCompact(isCompact);
	}
	
	public boolean isCompact() {
		return this.isCompact;
	}
	
	public void setCompact(boolean isCompact) {
		this.isCompact = isCompact;
		if (!isCompact) {
			setBorder(this.localBorder);
			
			// layout
			ToolbarLayout layout = new ToolbarLayout(ToolbarLayout.VERTICAL);
			layout.setStretchMinorAxis(true);
			layout.setMinorAlignment(ToolbarLayout.ALIGN_TOPLEFT);
			layout.setSpacing(1);
			setLayoutManager(layout);
		}
		else {
			setBorder(null);
			setLayoutManager(new StackLayout());
		}
	}

	@Override
	public Dimension getMinimumSize(int w, int h) {
		return minimumSize;
	}
	
}
