package org.infrawebs.axiom.editor.figures;

import org.eclipse.draw2d.CompoundBorder;
import org.eclipse.draw2d.Figure;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.infrawebs.axiom.model.Compactable;
import org.infrawebs.axiom.settings.ColorSettings;
import org.infrawebs.ontology.ui.OntoImages;

public class VariableFigure extends MemberOfFigure
{
	public VariableFigure(String variableType,
			String variableName, boolean existsFlag, boolean isCompact) {
		super(variableType, variableName, existsFlag, isCompact);
	}

	@Override
	public void setCompact(boolean isCompact) {
		super.setCompact(isCompact);

		// Show a shadow only in expanded mode.
		if (!isCompact) { 
			// Add a shadow to the border.
			ShadowBorder shadow = new ShadowBorder();
			shadow.setWidth(3);
			setBorder(new CompoundBorder(shadow, this.baseBorder));
		}
		else {
			setBorder(this.baseBorder);
		}

		// Realign the list figure.
		if (getBodyPanel().getChildren().size() > 0) {
			Compactable listFigure = (Compactable)getBodyPanel().getChildren().get(0);
			listFigure.setCompact(isCompact);
		}
	}
	
	@Override
	public Color getHeaderColorEnabled() {
		return ColorSettings.MEMBEROF_HEADER_BACK;
	}

	@Override
	public Color getHeaderColorDisabled() {
		return ColorSettings.MEMBEROF_HEADER_BACK_DISABLED;
	}

	@Override
	public Image getIconEnabled() {
		return OntoImages.getImage(OntoImages.CONCEPT);
	}
	
	@Override
	public Image getIconDisabled() {
		return OntoImages.getImage(OntoImages.CONCEPT_DISABLED);
	}
	
	@Override
	public Figure getDirectEditFigure() {
		return this.varNameFigure;
	}

}
