package org.infrawebs.axiom.model;

import java.util.List;
import java.util.ArrayList;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.ui.views.properties.IPropertyDescriptor;

public class ConnectionModel extends AbstractModel
{
	private static final long serialVersionUID = 200509271500L;

	private ModelWithConnections source, target;
	private List<Point> bendpoints = new ArrayList<Point>();
	public static final String ID_PROPERTY_BEND_POINT = "ID_PROPERTY_BEND_POINT";

	public void attachSource() {
		if (!this.source.listSourceConnections().contains(this)) {
			this.source.addSourceConnection(this);
		}
	}

	public void attachTarget() {
		if (!this.target.listTargetConnections().contains(this)) {
			this.target.addTargetConnection(this);
		}
	}

	public void detachSource() {
		this.source.removeSourceConnection(this);
	}

	public void detachTarget() {
		this.target.removeTargetConnection(this);
	}

	public ModelWithConnections getSource() {
		return this.source;
	}

	public ModelWithConnections getTarget() {
		return this.target;
	}

	public void setSource(ModelWithConnections model) {
		this.source = model;
	}

	public void setTarget(ModelWithConnections model) {
		this.target = model;
	}

	public void addBendpoint(int index, Point point) {
		this.bendpoints.add(index, point);
		firePropertyChange(ID_PROPERTY_BEND_POINT, null, null);
	}

	public List getBendpoints() {
		return this.bendpoints;
	}

	public void removeBendpoint(int index) {
		this.bendpoints.remove(index);
		firePropertyChange(ID_PROPERTY_BEND_POINT, null, null);
	}

	public void replaceBendpoint(int index, Point point) {
		this.bendpoints.set(index, point);
		firePropertyChange(ID_PROPERTY_BEND_POINT, null, null);
	}

	@Override
	public IPropertyDescriptor[] createPropertyDescriptors() {
		// No properties.
		return null;
	}

	@Override
	public Object getPropertyValue(Object id) {
		// No properties.
		return null;
	}

	@Override
	public void setPropertyValue(Object id, Object value) {
		// No editable properties.
	}

}
