package org.infrawebs.axiom.model;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.ui.views.properties.IPropertyDescriptor;

public class ContainerModel extends AbstractModel
{
	private static final long serialVersionUID = 200509271500L;

	public static final String ID_PROPERTY_CHILDREN = "ID_PROPERTY_CHILDREN";

	private List<ModelWithConnections> children = new ArrayList<ModelWithConnections>();

	public void addChild(ModelWithConnections child) {
		addChild(this.children.size(), child);
	}

	public void addChild(int index, ModelWithConnections child) {
		this.children.add(index, child);
		firePropertyChange(ID_PROPERTY_CHILDREN, null, null);
	}

	public List<ModelWithConnections> getChildren() {
		return this.children;
	}

	public void removeChild(Object child) {
		this.children.remove(child);
		firePropertyChange(ID_PROPERTY_CHILDREN, null, null);
	}

	public void reorderChild(ModelWithConnections child, int newIndex) {
		this.children.remove(child);
		this.children.add(newIndex, child);
		firePropertyChange(ID_PROPERTY_CHILDREN, null, null);
	}

	@Override
	public IPropertyDescriptor[] createPropertyDescriptors() {
		// No properties.
		return null;
	}

	@Override
	public Object getPropertyValue(Object id) {
		// No properties.
		return null;
	}

	@Override
	public void setPropertyValue(Object id, Object value) {
		// No editable properties.
	}
	
}
