package org.infrawebs.axiom.model;

import java.util.List;

public abstract class RefinableListModel extends ContainerModel
{
	private static final long serialVersionUID = 200510291900L;

	private ModelWithConnections owner = null;

	public RefinableListModel(ModelWithConnections owner) {
		this.owner = owner;
	}
	
	public ModelWithConnections getOwner() {
		return this.owner;
	}

	@Override
	public void addChild(int index, ModelWithConnections child) {
		if (!(child instanceof RefinableModel)) {
			throw new IllegalArgumentException("Cannot add a " +
					child.getClass().getName() + " to a RefinableListModel");
		}
		((RefinableModel)child).setOwner(this);
		super.addChild(index, child);
	}

	public abstract List<ModelWithConnections> listRefiningModels();
}
