package org.infrawebs.axiom.model.commands;


import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.infrawebs.axiom.model.ConnectionModel;

public class BendpointDeleteCommand extends Command {
	private ConnectionModel connection;
	private Point oldLocation;
	private int index;

	@Override
	public void execute() {
		this.oldLocation = (Point)this.connection.getBendpoints().get(this.index);
		this.connection.removeBendpoint(this.index);
	}

	public void setConnectionModel(Object model) {
		this.connection = (ConnectionModel) model;
	}

	public void setIndex(int i) {
		this.index = i;
	}

	@Override
	public void undo() {
		this.connection.addBendpoint(this.index, this.oldLocation);
	}
}
