package org.infrawebs.axiom.model.commands;

import org.eclipse.gef.commands.Command;
import org.infrawebs.axiom.model.ConnectionModel;

public class ConnectionCreateCommand extends Command {
	private ConnectionModel connection;
	
	public ConnectionCreateCommand(ConnectionModel connection) {
		this.connection = connection;
	}

	@Override
	public boolean canExecute() {
		if (this.connection.getSource() == null || this.connection.getTarget() == null)
			return false;
		if (this.connection.getSource().equals(this.connection.getTarget()))
			return false;
		return true;
	}

	public ConnectionModel getConnection() {
		return this.connection;
	}
	
	@Override
	public void execute() {
		this.connection.attachSource();
		this.connection.attachTarget();
	}

	@Override
	public void undo() {
		this.connection.detachTarget();
		this.connection.detachSource();
	}
}
