package org.infrawebs.axiom.model.commands;

import java.security.InvalidParameterException;

import org.eclipse.gef.commands.Command;
import org.infrawebs.axiom.model.AbstractModel;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;

public class ContainerDeleteChildCommand extends Command
{
	private ContainerModel container;
	private ModelWithConnections model;
	private int oldIndex;
	
	protected AbstractModel getModel() {
		return this.model;
	}
	
	public ContainerDeleteChildCommand(ContainerModel container, ModelWithConnections model) {
		if (!container.getChildren().contains(model)) 
			throw new InvalidParameterException("Trying to delete a non existant child!");
		
		this.container = container;
		this.model = model;
	}
	
	@Override
	public void execute() {
		this.oldIndex = this.container.getChildren().indexOf(this.model);
		if (this.oldIndex >= 0) { 
			this.container.removeChild(this.model);
		}
	}
	
	@Override
	public void undo() {
		if (this.oldIndex >= 0) { 
			this.container.addChild(this.oldIndex, this.model);
		}
	}
}
