package org.infrawebs.axiom.model.commands;


import java.util.ArrayList;
import java.util.List;

import org.infrawebs.axiom.model.ConnectionModel;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;

public class ContainerDeleteWithConnectionsCommand extends ContainerDeleteChildCommand
{
	public ContainerDeleteWithConnectionsCommand(ContainerModel container, ModelWithConnections model) {
		super(container, model);
	}

	private List<ConnectionModel> sourceConnections = new ArrayList<ConnectionModel>();
	private List<ConnectionModel> targetConnections = new ArrayList<ConnectionModel>();

	@Override
	public void execute() {
		ModelWithConnections model = (ModelWithConnections)getModel();
		this.sourceConnections.addAll(model.listSourceConnections());
		this.targetConnections.addAll(model.listTargetConnections());

		for (ConnectionModel connModel: this.sourceConnections) {
			connModel.detachSource();
			connModel.detachTarget();
		}
		for (ConnectionModel connModel: this.targetConnections) {
			connModel.detachSource();
			connModel.detachTarget();
		}
		
		super.execute();
	}

	@Override
	public void undo() {
		super.undo();
		
		for (ConnectionModel connModel: this.sourceConnections) {
			connModel.attachSource();
			connModel.attachTarget();
		}
		for (ConnectionModel connModel: this.targetConnections) {
			connModel.attachSource();
			connModel.attachTarget();
		}

		this.sourceConnections.clear();
		this.targetConnections.clear();
	}

}
