package org.infrawebs.axiom.model.commands;

import org.eclipse.gef.commands.Command;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;

public class ContainerMoveChildCommand extends Command
{
	private ContainerModel list;
	private ModelWithConnections child;
	private ModelWithConnections after;
	private int oldIndex;

	public ContainerMoveChildCommand(ContainerModel list, ModelWithConnections child, ModelWithConnections after) {
		this.list = list;
		this.child = child;
		this.after = after;
	}
	
	@Override
	public void execute() {
		this.oldIndex = this.list.getChildren().indexOf(this.child);
		int afterIndex = (this.after != null)
				? this.list.getChildren().indexOf(this.after)
				: this.list.getChildren().size();
		if (this.oldIndex != afterIndex && this.oldIndex + 1 != afterIndex) {
			if (afterIndex < this.oldIndex) {
				this.list.reorderChild(this.child, afterIndex);
			}
			else {
				this.list.reorderChild(this.child, afterIndex - 1);
			}
		}
	}
	
	@Override
	public void undo() {
		this.list.reorderChild(this.child, this.oldIndex);
	}
}
