package org.infrawebs.axiom.model.commands;

import org.eclipse.gef.commands.Command;
import org.infrawebs.axiom.model.VarNameHolderModel;
import org.infrawebs.axiom.model.VarNameModel;

public class VarNameChangeCommand extends Command {
	private VarNameModel oldVarNameModel, newVarNameModel;
	private VarNameHolderModel holder;

	public VarNameChangeCommand(VarNameHolderModel holder, VarNameModel newVarNameModel) {
		this.holder = holder;
		this.newVarNameModel = newVarNameModel;
	}
	
	public VarNameHolderModel getHolder() {
		return this.holder;
	}
	
	@Override
	public void execute() {
		if (this.holder.getVarNameModel() != this.newVarNameModel) {
			this.oldVarNameModel = this.holder.getVarNameModel();
			this.holder.setVarNameModel(this.newVarNameModel);
		}
	}

	@Override
	public void undo() {
		if (this.holder.getVarNameModel() != this.oldVarNameModel) {
			this.holder.setVarNameModel(this.oldVarNameModel);
			this.oldVarNameModel = null;
		}
	}

}
