package org.infrawebs.axiom.outline.editparts;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.editparts.AbstractTreeEditPart;
import org.infrawebs.axiom.model.AbstractModel;
import org.infrawebs.axiom.model.ModelWithConnections;

public abstract class BaseTreeEditPart extends AbstractTreeEditPart implements
		PropertyChangeListener {

	@Override
	public void activate() {
		super.activate();
		((AbstractModel)getModel()).addPropertyChangeListener(this);
	}

	@Override
	public void deactivate() {
		((AbstractModel)getModel()).removePropertyChangeListener(this);
		super.deactivate();
	}

	public void propertyChange(PropertyChangeEvent evt) {
		// Always refresh the text in the outline no matter what property has changed.
		refreshVisuals();
	}

	protected List<ModelWithConnections> getDeeperModelChildren(List<ModelWithConnections> allChildren) {
		List<ModelWithConnections> localChildren = new ArrayList<ModelWithConnections>();
		ModelWithConnections model = (ModelWithConnections)getModel();
		int depth = model.getGrafDepth();
		if (depth == ModelWithConnections.UNKNOWN_DEPTH) {
			return localChildren;
		}

		for (ModelWithConnections child: allChildren) {
			int childDepth = child.getGrafDepth(); 
			if (childDepth != ModelWithConnections.UNKNOWN_DEPTH &&
					childDepth > depth) {
				localChildren.add(child);
			}
		}
		return localChildren;
	}

}