package org.infrawebs.axiom.outline.editparts;

import java.beans.PropertyChangeEvent;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.infrawebs.axiom.model.AxiomRootModel;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;

public class ContentsTreeEditPart extends BaseTreeEditPart
{
	/**
	 * Returns the first and only AxiomRootModel.
	 */
	@Override
	protected List getModelChildren() {
		List<ModelWithConnections> modelChildren = new ArrayList<ModelWithConnections>();
		for (ModelWithConnections model: ((ContainerModel)getModel()).getChildren()) {
			if (model instanceof AxiomRootModel) {
				modelChildren.add(model);
				return modelChildren;
			}
		}
		return Collections.EMPTY_LIST;
	}

	@Override
	protected void refreshVisuals() {
		setWidgetText("ContentsTreeEditPart"); // tova nishto ne izvezhda, zashtoto tozi Widget e vsyshtnost samoto Tree!
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		super.propertyChange(evt);

		if (evt.getPropertyName().equals(ContainerModel.ID_PROPERTY_CHILDREN)) {
			refreshChildren();
		}
	}
}
