package org.infrawebs.axiom.outline.editparts;

import java.util.List;

import org.eclipse.gef.EditPolicy;
import org.infrawebs.axiom.editor.editpolicies.DeleteWithConnectionsEditPolicy;
import org.infrawebs.axiom.model.OperatorModel;
import org.infrawebs.axiom.settings.ImageSettings;

public class OperatorTreeEditPart extends TreeEditPartWithConnections
{
	@Override
	protected void createEditPolicies() {
		super.createEditPolicies();
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new DeleteWithConnectionsEditPolicy());
	}

	@Override
	protected void refreshVisuals() {
		OperatorModel model = (OperatorModel)getModel();
		setWidgetText(model.getOperatorTypeAsString()); // "Operator type: " +
		setWidgetImage(ImageSettings.getImage(ImageSettings.OPERATOR));
	}

	@Override
	protected List getModelChildren() {
		OperatorModel operator = (OperatorModel)getModel();
		return getDeeperModelChildren(operator.listOperands());
	}

}
