package org.infrawebs.axiom.outline.editparts;

import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.EditPart;
import org.infrawebs.axiom.model.AxiomRootModel;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.InstanceModel;
import org.infrawebs.axiom.model.MemberOfModel;
import org.infrawebs.axiom.model.OperatorModel;
import org.infrawebs.axiom.model.ParameterModel;
import org.infrawebs.axiom.model.RelationModel;
import org.infrawebs.axiom.model.ValueInstanceModel;
import org.infrawebs.axiom.model.VariableModel;
import org.infrawebs.common.Messages;

public class TreeEditPartFactory implements EditPartFactory {

	public EditPart createEditPart(EditPart context, Object model) {
		EditPart part = null;

		if (model instanceof ContainerModel)
			part = new ContentsTreeEditPart();
		else if (model instanceof InstanceModel)
			part = new InstanceTreeEditPart();
		else if (model instanceof ValueInstanceModel)
			part = new ValueInstanceTreeEditPart();
		else if (model instanceof VariableModel)
			part = new VariableTreeEditPart();
		else if (model instanceof RelationModel)
			part = new RelationTreeEditPart();
		else if (model instanceof MemberOfModel)
			part = new MemberOfTreeEditPart();
		else if (model instanceof OperatorModel)
			part = new OperatorTreeEditPart();
		else if (model instanceof AxiomRootModel)
			part = new AxiomRootTreeEditPart();
		else if (model instanceof ParameterModel)
			part = new ParameterTreeEditPart();
		else 
			Messages.showError("Error in TreeEditPartFactory:\n" +
					"AxiomEditor doesn't know how to handle: " 
					+ model.getClass().toString());

		if (part != null)
			part.setModel(model);

		return part;
	}

}