package org.infrawebs.axiom.outline.editparts;

import java.util.List;

import org.eclipse.gef.EditPolicy;
import org.infrawebs.axiom.editor.editpolicies.DeleteVariableEditPolicy;
import org.infrawebs.axiom.model.ModelWithConnections;
import org.infrawebs.axiom.model.VariableModel;
import org.infrawebs.axiom.settings.ImageSettings;

public class VariableTreeEditPart extends MemberOfTreeEditPart
{
	@Override
	protected void createEditPolicies() {
		super.createEditPolicies();
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new DeleteVariableEditPolicy());
	}

	@Override
	protected void refreshVisuals() {
		super.refreshVisuals();
		setWidgetImage(ImageSettings.getImage(ImageSettings.VARIABLE));
	}

	@Override
	protected List getModelChildren() {
		VariableModel variable = (VariableModel)getModel();
		List<ModelWithConnections> deeperChildren = getDeeperModelChildren(
				variable.getRefinableList().listRefiningModels());
		deeperChildren.addAll(variable.listChildRelations());
		return deeperChildren;
	}
	
}
