package org.infrawebs.axiom.plugin.extras;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;
import org.infrawebs.axiom.plugin.AxiomEditorPlugin;

public class SampleView extends ViewPart
{
	public static final String VIEW_ID = "org.infrawebs.axiom.plugin.extras.sampleView"; 

    private TableViewer viewer;

	class ViewContentProvider implements IStructuredContentProvider
	{
		public void inputChanged(Viewer v, Object oldInput, Object newInput) {
			// Do nothing. This is a sample.
		}

		public void dispose() {
			// Nothing to dispose.
		}

		public Object[] getElements(Object parent) {
			return new String[] {
					AxiomEditorPlugin.getResourceString("One"), //$NON-NLS-1$
					AxiomEditorPlugin.getResourceString("Two"), //$NON-NLS-1$
					AxiomEditorPlugin.getResourceString("Three") //$NON-NLS-1$
			};
		}
	}

	class ViewLabelProvider extends LabelProvider
		implements ITableLabelProvider
	{
		public String getColumnText(Object obj, int index) {
			return getText(obj);
		}
		public Image getColumnImage(Object obj, int index) {
			return getImage(obj);
		}
		@Override
		public Image getImage(Object obj) {
			return PlatformUI.getWorkbench().getSharedImages().getImage(
					ISharedImages.IMG_OBJ_ELEMENT);
		}
	}

	@Override
    public void createPartControl(Composite parent) {
		this.viewer = new TableViewer(parent, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
    	this.viewer.setContentProvider(new ViewContentProvider());
        this.viewer.setLabelProvider(new ViewLabelProvider());
        this.viewer.setInput(this);
    }

	@Override
    public void setFocus() {
        this.viewer.getControl().setFocus();
    }
}