package org.infrawebs.ontology.shells;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.omwg.ontology.OntologyElement;
import org.omwg.ontology.Type;

public abstract class RefinableShell implements OntologyElement
{
	public Type getFirstType() {
		return listTypes().iterator().next();
	}

	public Set<Type> listTypes() {
		Set original = internalListTypes();
		Set<Type> result = new HashSet<Type>(original.size());
		Iterator i = original.iterator();
		while (i.hasNext()) {
			result.add((Type)i.next());
		}
		return result;
	}

	protected abstract Set internalListTypes();
	public abstract boolean isConstraining();
	public abstract OntologyElement getParent();
}
