package org.infrawebs.ontology.ui;

import org.eclipse.swt.graphics.Image;

public class OntoImages
{
	public static final int CONCEPT = 0;
	public static final int CONCEPT_DISABLED = 1;
	public static final int INSTANCE = 2;
	public static final int INSTANCE_DISABLED = 3;
	public static final int RELATION = 4;
	public static final int RELATION_DISABLED = 5;
	public static final int ATTRIBUTE_NEW = 6;
	public static final int ATTRIBUTE_NEW_DISABLED = 7;
	public static final int ATTRIBUTE_INHERITED = 8;
	public static final int ATTRIBUTE_INHERITED_DISABLED = 9;
	public static final int ATTRIBUTE_OVERRIDEN = 10;
	public static final int ATTRIBUTE_OVERRIDEN_DISABLED = 11;
	public static final int RELATION_PARAMETER = 12;
	public static final int RELATION_PARAMETER_DISABLED = 13;
	public static final int RELATION_INSTANCE = 14;
	public static final int REBUILD_ONTO_INDEX = 15;
	public static final int SPHERE = 16;
	public static final int NFP = 17;
	public static final int NAMESPACE = 18;
	public static final int IMPORTED_ONTOLOGY = 19;
	public static final int MEDIATOR = 20;
	public static final int AXIOM = 21;
	public static final int OPEN_FILE = 22;
	public static final int SAVE_FILE = 23;

	// NOTE: Update this image count accordingly.
	public static final int IMAGE_COUNT = 24;
	
	private static String[] fileNames = new String[IMAGE_COUNT];
	private static Image[] images = new Image[IMAGE_COUNT];
	
	static {
		fileNames[CONCEPT] = "Concept.gif";
		fileNames[CONCEPT_DISABLED] = "ConceptFade.gif";
		fileNames[INSTANCE] = "Instance.gif";
		fileNames[INSTANCE_DISABLED] = "InstanceFade.gif";
		fileNames[RELATION] = "Relation.gif";
		fileNames[RELATION_DISABLED] = "RelationFade.gif";
		fileNames[ATTRIBUTE_NEW] = "AttrNew.gif";
		fileNames[ATTRIBUTE_NEW_DISABLED] = "AttrNewFade.gif";
		fileNames[ATTRIBUTE_INHERITED] = "AttrInherited.gif";
		fileNames[ATTRIBUTE_INHERITED_DISABLED] = "AttrInheritedFade.gif";
		fileNames[ATTRIBUTE_OVERRIDEN] = "AttrOverriden.gif";
		fileNames[ATTRIBUTE_OVERRIDEN_DISABLED] = "AttrOverridenFade.gif";
		fileNames[RELATION_PARAMETER] = "Parameter.gif";
		fileNames[RELATION_PARAMETER_DISABLED] = "ParameterFade.gif";
		fileNames[RELATION_INSTANCE] = "RelationInstance.gif";
		fileNames[REBUILD_ONTO_INDEX] = "Refresh.gif";
		fileNames[SPHERE] = "Metadata.gif";
		fileNames[NFP] = "Nfp.gif";
		fileNames[NAMESPACE] = "Namespace.gif";
		fileNames[IMPORTED_ONTOLOGY] = "Ontology.gif";
		fileNames[MEDIATOR] = "Mediator.gif";
		fileNames[AXIOM] = "Axiom.gif";
		fileNames[OPEN_FILE] = "OpenFile.gif";
		fileNames[SAVE_FILE] = "SaveFile.gif";

		for (int i = 0; i < IMAGE_COUNT; i++) {
			try {
				String fileName = "icons/" + fileNames[i];
				images[i] = new Image(null, OntoImages.class.getResourceAsStream(fileName));
			}
			catch (Exception ex) {
				// TODO: Use default images.
			}
		}
	}
	
	public static Image getImage(int index) {
		return (index >= 0) && (index < IMAGE_COUNT) ?
				images[index] : null;
	}
	
}
